-- author RivalBomb

claasC900 = {};

function claasC900.prerequisitesPresent(specializations)
    return true;
end;

function claasC900:load(xmlFile)
	if hasXMLProperty(xmlFile, "vehicle.blade") then
		print("Warning: vehicle.blade is deprecated. Use vehicle.blades.blade instead");
	end;
	
	self.blades = {};
	local bladI = 0;
	while true do
		local blakey = string.format("vehicle.blades.blade(%d)",bladI);
		local index = Utils.indexToObject(self.components, getXMLString(xmlFile, blakey.."#index"));
		local speed = Utils.getNoNil(getXMLFloat(xmlFile, blakey.."#speed"), 1);
		if index==nil then
			break;
		end;
		bladI = bladI+1;
		self.blades[bladI] = {};
		self.blades[bladI].index = index;
		self.blades[bladI].speed = speed;
		self.blades[bladI].curSpeed = 0;
		self.blades[bladI].dir = 1;
		self.blades[bladI].pos = 0;
	end;
	
	
	-- Reel Fruit Objects (rfo)
	self.rfo = {};
	self.rfo.barleyObj = {};
	self.rfo.wheatObj = {};
	
	local mainkey = "vehicle.reelFruitObjects";
	self.reelArmNode = Utils.indexToObject(self.components, getXMLString(xmlFile, mainkey.."#reelArmNode"));
	self.reelNode = Utils.indexToObject(self.components, getXMLString(xmlFile, mainkey.."#reelNode"));
	self.maxFruitsPerSpike = Utils.getNoNil(getXMLInt(xmlFile, mainkey.."#maxFruitsPerSpike"), 3);
	self.rfo.minMaxX = Utils.getVectorNFromString(getXMLString(xmlFile, mainkey.."#minMaxX"), 2);
	
	local i = 0;
	while true do
		local key = string.format("vehicle.reelFruitObjects.barleyObjAtSpike%d", i+1);
		local index = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
		if index==nil then
			break;
		else
			setVisibility(index, false);
		end;
		i = i +1;
		self.rfo.barleyObj[i] = {};
		self.rfo.barleyObj[i][1] = index;
	end;
	local j = 0;
	while true do
		local key = string.format("vehicle.reelFruitObjects.wheatObjAtSpike%d", j+1);
		local index = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
		if index==nil then
			break;
		else
			setVisibility(index, false);
		end;
		j = j +1;
		self.rfo.wheatObj[j] = {};
		self.rfo.wheatObj[j][1] = index;
	end;
	self.numSpikess = (#self.rfo.barleyObj + #self.rfo.wheatObj)/2;
	for k=1, self.numSpikess do
		for l=1, self.maxFruitsPerSpike-1 do
			local fruitBarleyClone = clone(self.rfo.barleyObj[k][1], true);
			local fruitWheatClone = clone(self.rfo.wheatObj[k][1], true);
			setVisibility(fruitBarleyClone, false);
			setVisibility(fruitWheatClone, false);
			table.insert(self.rfo.barleyObj[k], fruitBarleyClone);
			table.insert(self.rfo.wheatObj[k], fruitWheatClone);
		end;
	end;
	self.percentArea = 0;
end;
function claasC900:delete()
end;
function claasC900:mouseEvent(posX, posY, isDown, isUp, button)
end;
function claasC900:keyEvent(unicode, sym, modifier, isDown)
end;
function claasC900:update(dt)
	if self:getIsActive() then
		for bladi=1, #self.blades do
			if self.reelStarted then
				self.blades[bladi].curSpeed = math.min(self.blades[bladi].curSpeed+0.012, self.blades[bladi].speed);
			else
				self.blades[bladi].curSpeed = math.max(self.blades[bladi].curSpeed-0.015, 0);
			end;
			if self.blades[bladi].pos >= 0.08 then self.blades[bladi].dir=-1 elseif self.blades[bladi].pos <= -0.08 then self.blades[bladi].dir=1 end;
			self.blades[bladi].pos = self.blades[bladi].pos+(0.0125*self.blades[bladi].curSpeed*self.blades[bladi].dir);
			setTranslation(self.blades[bladi].index, self.blades[bladi].pos,0,0);
		end;


		local rotArmX,_,_ = getRotation(self.reelArmNode);
		local rotX,_,_ = getRotation(self.reelNode);
		if rotArmX < math.rad(11) and self.reelStarted and self.lastCutterAreaBiggerZero then
			if self.currentInputFruitType == FruitUtil.FRUITTYPE_BARLEY then
				for i=1, self.maxFruitsPerSpike do
					local isActive = math.random(1,15)==8;
					if isActive then
						local _,by,bz = getTranslation(self.rfo.barleyObj[math.floor(rotX%6)+1][i]);
						local bx = math.random(self.rfo.minMaxX[1]*100, self.rfo.minMaxX[2]*100)/100;
						setTranslation(self.rfo.barleyObj[math.floor(rotX%6)+1][i], bx, by, bz);
						setVisibility(self.rfo.barleyObj[math.floor(rotX%6)+1][i], true);
					end;
				end;
			end;
			if self.currentInputFruitType == FruitUtil.FRUITTYPE_WHEAT then
				for i=1, self.maxFruitsPerSpike do
					local isActive = math.random(1,15)==8;
					if isActive then
						local _,by,bz = getTranslation(self.rfo.wheatObj[math.floor(rotX%6)+1][i]);
						local bx = math.random(self.rfo.minMaxX[1]*100, self.rfo.minMaxX[2]*100)/100;
						setTranslation(self.rfo.wheatObj[math.floor(rotX%6)+1][i], bx, by, bz);
						setVisibility(self.rfo.wheatObj[math.floor(rotX%6)+1][i], true);
					end;
				end;
			end;
		end;
		for i=1, self.numSpikess do
			local k=i;
			if k==6 then k=0 end;
			if (math.floor(rotX%6)+1) == (k+1) then
				for j=1, self.maxFruitsPerSpike do
					--if self.rfo.wheatObj[i][j] ~= nil then
						setVisibility(self.rfo.wheatObj[i][j], false);
					--end;
					--if self.rfo.barleyObj[i][j] ~= nil then
						setVisibility(self.rfo.barleyObj[i][j], false);
					--end;
				end;
			end;
		end;
	end;
end;
function claasC900:updateTick(dt)
end;
function claasC900:draw()
end;